//+------------------------------------------------------------------+
//|                                             Fantastic Four 3.mq4 |
//|                                                         Ji Ching |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Ji Ching"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Magenta
#property indicator_color2 Magenta
#property indicator_color3 Yellow

extern int LineStyle = STYLE_SOLID;
extern color LineColor = Gray;
extern int LineStyle2 = STYLE_DOT;
extern color LineColor2 = LightGray;
extern int Range = 75;
extern int Level = 10;
extern int Date = 0;

double Buf1[], Buf2[], Buf3[];
double LastHigh, LastLow;
string priceinfo;
string pair[]={"AUDCAD","AUDCHF","AUDJPY","AUDNZD","AUDUSD",
               "CADCHF","CADJPY","CHFJPY",
               "EURAUD","EURCAD","EURGBP","EURJPY","EURNZD","EURUSD",
               "GBPAUD","GBPCAD","GBPCHF","GBPJPY","GBPNZD","GBPUSD",
               "NZDCAD","NZDCHF","NZDJPY","NZDUSD",
               "USDCAD","USDCHF","USDJPY","SILVER"};
double point[]={0.0001,0.0001,0.01,0.0001,0.0001,
                0.0001,0.01,0.01,
                0.0001,0.0001,0.0001,0.01,0.0001,0.0001,
                0.0001,0.0001,0.0001,0.01,0.0001,0.0001,
                0.0001,0.0001,0.01,0.0001,
                0.0001,0.0001,0.01,0.01};
int digit[] ={4,4,2,4,4,
              4,2,2,
              4,4,4,2,4,4,
              4,4,4,2,4,4,
              4,4,2,4,
              4,4,2,2};

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0, Buf1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1, Buf2);    
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2, Buf3);   
   /*int i,j,k;
   string temp;
   k = ArraySize(pair);
   for (i=0; i<=k-2; i++)
     for (j=i+1; i<=k-1; j++)    
       if (pair[i]>pair[j])
       {
         temp = pair[i];
         pair[i] = pair[j];
         pair[j] = temp;
       }*/
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()   
  {
   int numobj = ObjectsTotal();
   
   for (int i=numobj; i>=0; i--)
   {
     string nama = ObjectName(i);
     if (StringSubstr(nama, 0, 7) == "[Magic]")
       ObjectDelete(nama);
     if (StringSubstr(nama, 0, 7) == "[Range]")
       ObjectDelete(nama);       
   }
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  { 
   static datetime lasttime = 0;
   static datetime lastperiod = 0;
   
   int i;
   int ssp = Bid / Point;
   ssp = ssp - ssp % 100;
   
   for (i=-Level; i<Level; i++)
   {
     int number = ssp + (i*100) - 20;
     double ds1= number*Point;
     SetLevel(DoubleToStr(ds1, Digits), ds1, LineStyle2, LineColor2);
     
     number = ssp + (i*100) + 20;
     ds1= number*Point;
     SetLevel(DoubleToStr(ds1, Digits), ds1, LineStyle2, LineColor2);
   
     number = ssp + (i*100) - 50;
     ds1= number*Point;
     SetLevel(DoubleToStr(ds1, Digits), ds1, LineStyle, LineColor);

     number = ssp + (i*100);
     ds1= number*Point;
     SetLevel(DoubleToStr(ds1, Digits), ds1, LineStyle, LineColor);        
   }     

   int counted_bars=IndicatorCounted();
   if (counted_bars<0) return (-1);
   //if (counted_bars>0) counted_bars--;
   int pos = Bars;// - counted_bars;
     
   double buka,atas,bawah,buka1;
    
   while (pos>=0)
   { 
     if (TimeHour(Time[pos])==0)
     {
       //double buka = iOpen(0, PERIOD_D1, 0);     
       buka = Open[pos]; 
       if (TimeDayOfWeek(Time[pos])==1)              
       {         
         atas = buka + (Point*Range-30*Range*Point/100);
         bawah = buka - (Point*Range-30*Range*Point/100);       
       }
       else if (TimeDayOfWeek(Time[pos])==5)
       {
         atas = buka + (Point*Range+50*Range*Point/100);
         bawah = buka - (Point*Range+50*Range*Point/100);       
       }       
       else
       {
         atas = buka + (Point*Range);
         bawah = buka - (Point*Range);              
       }
       buka1 = buka;
     }
     Buf1[pos] = atas;
     Buf2[pos] = bawah;         
     Buf3[pos] = buka1;              
     pos--;
   }  
   ObjectCreate("[Magic]Ask", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("[Magic]Ask", DoubleToStr(Bid,Digits), 30, "Arial", Aqua);
   ObjectSet("[Magic]Ask", OBJPROP_CORNER, 1);
   ObjectSet("[Magic]Ask", OBJPROP_XDISTANCE, 20);
   ObjectSet("[Magic]Ask", OBJPROP_YDISTANCE, 20); 
   
   // Check another pairs
   priceinfo = "Fantastic Four v3.0\n";
      
   int count = ArraySize(pair);   
   for (i=0; i<count; i++) SetInfo(pair[i], Range, Date, point[i], digit[i]);
   Comment(priceinfo);
/*   double haribuka = iOpen("USDCHF", PERIOD_D1, 0) / Point;
   double haritinggi = iHigh("USDCHF", PERIOD_D1, 0) / Point;
   double harirendah = iLow("USDCHF", PERIOD_D1, 0) / Point;
   if (haritinggi>haribuka+40)
     Comment("Atas"+DoubleToStr(haritinggi,0));
   else if (harirendah<haribuka-20)
     Comment("Bawah"+DoubleToStr(harirendah,0));   */
           
   //Comment("Fantastic Four Modif v2.0");
   return(0);
  }
  
void SetInfo(string simbol, int range, int waktu, double poin, double digi)
  {
   /*double haribuka = iOpen(simbol, PERIOD_D1, waktu) / poin;
   double haritinggi = iHigh(simbol, PERIOD_D1, waktu) / poin;
   double harirendah = iLow(simbol, PERIOD_D1, waktu) / poin;
   */
   
   double haribuka = iOpen(simbol, PERIOD_D1, waktu);
   double haritinggi = iHigh(simbol, PERIOD_D1, waktu);
   double harirendah = iLow(simbol, PERIOD_D1, waktu);   
   //int rangebaru;
   double rangebaru,rangebaru1;
   
   datetime hari = iTime(simbol, PERIOD_D1, waktu); 
   
   //rangebaru = Range-30*Range/100;   
   //rangebaru = Range+50*Range/100;
   if (TimeDayOfWeek(hari)==1)              
   {
     rangebaru = haribuka + (poin*Range-30*Range*poin/100);     
     rangebaru1 = haribuka - (poin*Range-30*Range*poin/100);      
   }
   else if (TimeDayOfWeek(hari)==5)
   {
     rangebaru = haribuka + (poin*Range+50*Range*poin/100);
     rangebaru1 = haribuka - (poin*Range+50*Range*poin/100);
   }
   else
   {
     rangebaru = haribuka + (poin*Range);
     rangebaru1 = haribuka - (poin*Range);     
   }
   
   //if (simbol=="SILVER") Alert(poin,haribuka);   
   
   //Comment(simbol+' '+DoubleToStr(haritinggi,0));   
   //Comment(simbol+' '+DoubleToStr(harirendah,0));  
   //if (haritinggi>haribuka+rangebaru)
   //priceinfo = priceinfo + simbol + " : Up " + DoubleToStr((haribuka+rangebaru)*poin,digi) + "\n";   
   //else if (harirendah<haribuka-rangebaru)   
   //priceinfo = priceinfo + simbol + " : Down " + DoubleToStr((haribuka-rangebaru)*poin,digi) + "\n";
   if (haritinggi>rangebaru-10*poin)
     priceinfo = priceinfo + simbol + " : Up " + DoubleToStr(rangebaru,digi) + "\n";         
   else if (harirendah<rangebaru1+10*poin)
     priceinfo = priceinfo + simbol + " : Down " + DoubleToStr(rangebaru1,digi) + "\n";         
  }
  
void SetLevel(string text, double level, int linestyle, color linecolor)
  {
   string nama = "[Magic] " + text;
   
   if (ObjectFind(nama) != 0)
   {
     ObjectCreate(nama, OBJ_HLINE, 0, 0, level);
     ObjectSet(nama, OBJPROP_STYLE, linestyle);
     ObjectSet(nama, OBJPROP_COLOR, linecolor);
   }
   else
   {
     ObjectMove(nama, 0, 0, level);
   }  
  }
 
void SetLabel(string name, string text, datetime waktu, double level, color Color)
{
    string nama = "[Range] " + name;
    if(ObjectFind(nama) != 0)
    { 
        ObjectCreate(nama, OBJ_TEXT, 0, waktu, level);            
        ObjectSetText(nama, text, 10, "Arial Bold", EMPTY);
        ObjectSet(nama, OBJPROP_COLOR, Color);
    }
    else
    {
        ObjectMove(nama, 0, waktu, level);
    }
}
  
//+------------------------------------------------------------------+